#ifdef NO_UI
#define cbdMaxTextLength (1000)
#else
/* all this just for cbdMaxTextLength! */
#include <PalmOS.h>
#include <HandEra/Vga.h>
#include <Sony/SonyCLIE.h>
#endif

#define MAXLEN (cbdMaxTextLength)

struct cbuf
{
  int length;
  unsigned char data[MAXLEN];
};

typedef unsigned char key[16];

/* error codes */
#define ERR_OVERFLOW (-1)
#define ERR_TRUNCATED (-2)
#define ERR_NO_HEADER (-3)

/* armor */
#define ARMOR_HEADER 'arQx'
#define ARMOR_SPACING (4)	/* number of blocks between spaces */

/* erases a cbuf */
void erase(struct cbuf *c);

/* set a key from a passphrase */
void setkey(key k, const char *p, unsigned int len);

/* pad, encrypt, & escape */
int code(key k, struct cbuf *v);

/* reverse of above */
int uncode(key k, struct cbuf *v);

/* armor a cbuf */
int armor(const struct cbuf *in, struct cbuf *out);

/* reverse of above */
int unarmor(const struct cbuf *in, struct cbuf *out);

